#include <stdlib.h>
#include <string.h>
#include "geometry.h"

geometry *geometry_new(void)
{
	return calloc(1, sizeof(geometry));
}

geometry *geometry_copy(geometry *src)
{
	geometry *new = calloc(1, sizeof(geometry));

	memcpy(new, src, sizeof(geometry));

	return new;
}

#include <stdio.h>
#define IS_OVERLAP(x, y, a, b) ( y > a && b > x)
int geometry_overlapped_p(geometry *a, geometry *b)
{
	int rv;

	if (IS_OVERLAP(a->shinkou_pos, a->shinkou_pos + a->shinkou_len,
		       b->shinkou_pos, b->shinkou_pos + b->shinkou_len) &&
	    IS_OVERLAP(a->chokkaku_pos, a->chokkaku_pos + a->chokkaku_len,
		       b->chokkaku_pos, b->chokkaku_pos + b->chokkaku_len))
		rv = 1;
	else
		rv = 0;

/*	fprintf(stderr, "(%d:%d, %d:%d) overlap (%d:%d, %d:%d) %s\n",
		a->shinkou_pos, a->chokkaku_pos, a->shinkou_len, a->chokkaku_len,
		b->shinkou_pos, b->chokkaku_pos, b->shinkou_len, b->chokkaku_len,
		(rv ? "True" : "False")); */

	return rv;
}
