
#ifndef LINE_H
#define LINE_H

#include "tategaki.h"
#include "t_drawer.h"
#include "geometry.h"
#include <wchar.h>

typedef struct {
	wchar_t *str;
	geometry *geo;
	int ctrl_p;
	int tate_chu_yoko;
} word;

typedef struct {
	t_drawer *drawer;
	word **words;		/* Բʬʸ */
	geometry *geo;
	geometry *next_pos;	/* Ǹʸθ塢θҥ */
	float line_height;
	geometry *screen_geo;
} line;

/* PROTOTYPE_BEGIN */
void line_expose_callback(line *self, geometry *area);
geometry *word_get_extents(word *w, line *l);
void word_calc_geometry(word *w, int line_chokkaku_len, line *l);
void line_calc_geometry(line *self, int shinkou_max);
void line_add_str(line *self, wchar_t *str);
line *line_new(wchar_t *str, t_drawer *drawer, geometry *screen_geo);
void line_print(line *self);
void line_set_origin(line *self, geometry *origin) ;
/* PROTOTYPE_END */

#endif
