#ifndef TATEGAKI_H
#define TATEGAKI_H
#include <stdio.h>
#include <assert.h>
#define __USE_GNU
#include <wchar.h>
#include <unistd.h>
#include <string.h>
#include <assert.h>
#include <stdlib.h>

#ifndef NDEBUG
#define DEBUG_INT(var) do { fprintf(stderr, "%s == %d\n", #var, var); } while (0)
#define DEBUG_STR(var) do { fprintf(stderr, "%s == %s\n", #var, var); } while (0)
// #define DEBUG_WCS(str) do { char tmp[1024]; wcstombs(tmp, str, 1024); fprintf(stderr, "%s\n", tmp); } while (0)
static inline void DEBUG_WCS(wchar_t *str)
{
	char tmp[1024];

	wcstombs(tmp, str, 1024);
	fprintf(stderr, "%s\n", tmp);
}
#define DEBUG_PRINT(str) do { fprintf(stderr, "%s", str); } while (0)
#define DIE(str) do { fprintf(stderr, "%s:%d: %s", __FILE__, __LINE__, str); } while (0)
#else
#define DEBUG_INT(var)
#define DEBUG_STR(var)
#define DEBUG_WCS(str)
#define DEBUG_PRINT(str)
#define DIE(str)
#endif

extern Bool tate_chu_yoko_mode;
extern char *appname;
extern int locale_eucjp_p;
#endif
